#include "sprite.h"

// RXgN^
Sprite::Sprite()
{
	pos.x = pos.y = 0.0f;
	width = 0;
	height = 0;
	divU = 1;
	divV = 1;
	numU = 0;
	numV = 0;
	rotate = 0.0f;
}
// fXgN^
Sprite::~Sprite(){}

void Sprite::SetPos(float x,float y)
{
	pos.x = x;
	pos.y = y;
}
void Sprite::SetWidth(int Width,int Height)
{
	width = Width;
	height = Height;
}

void Sprite::SetRotate(float Rotate)
{
	rotate = Rotate;
}

void Sprite::UpdatePos(float x,float y)
{
	pos.x += x;
	pos.y += y;
}
void Sprite::UpdateRotate(float Rotate)
{
	rotate += Rotate;
}

void Sprite::SetDivide(unsigned int DivU,unsigned int DivV)
{
	if(DivU <= 0 || DivV <= 0)
		return;

	divU = DivU;
	divV = DivV;
}

void Sprite::SetUVNum(unsigned int NumU,unsigned int NumV)
{
	if(NumU >= divU)
		return;
	if(NumV >= divV)
		return;

	numU = NumU;
	numV = NumV;
}

void Sprite::Draw(IDirect3DDevice9* pDevice3D,IDirect3DTexture9* pTexture,bool isTurn)
{
	// _Zbg
	Vertex vtx[4]={
		{ (float) width/2,(float)-height/2, 0.0f, 1.0f,(isTurn ? (float)numU/divU : (float)(numU + 1)/divU), (float)numV/divV},
		{ (float) width/2,(float) height/2, 0.0f, 1.0f,(isTurn ? (float)numU/divU : (float)(numU + 1)/divU), (float)(numV + 1)/divV}, 
		{ (float)-width/2,(float)-height/2, 0.0f, 1.0f,(isTurn ? (float)(numU + 1)/divU : (float)numU/divU), (float)numV/divV}, 
		{ (float)-width/2,(float) height/2, 0.0f, 1.0f,(isTurn ? (float)(numU + 1)/divU : (float)numU/divU), (float)(numV + 1)/divV} 
	};

	for(int i = 0;i < 4;++i){
		float x = vtx[i].x * cosf(rotate) - vtx[i].y * sinf(rotate);
		float y = vtx[i].x * sinf(rotate) + vtx[i].y * cosf(rotate);
		vtx[i].x = x + pos.x;
		vtx[i].y = y + pos.y;
	}
	// eNX`Zbg
	pDevice3D->SetTexture(0,pTexture);
	// _\̐錾Zbg
	pDevice3D->SetFVF(SPRITE_FVF);
	// XvCg`
	pDevice3D->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,vtx,sizeof(Vertex));
}


// LE{bNXiQj
struct OBB 
{
   D3DXVECTOR2	Pos;        // ʒu
   D3DXVECTOR2	Dir[2];		// XYeW̌X\xNg
   float		Length[2];  // e̒̔
};


// OBB쐬
void CreateOBB(OBB* pOutOBB,const D3DXVECTOR2& Pos,const D3DXMATRIX& RotateMtx,const D3DXVECTOR2& Length)
{
	pOutOBB->Pos = Pos;
	pOutOBB->Length[0] = Length.x;
	pOutOBB->Length[1] = Length.y;
	pOutOBB->Dir[0] = D3DXVECTOR2(RotateMtx._11,RotateMtx._12);
	pOutOBB->Dir[1] = D3DXVECTOR2(RotateMtx._21,RotateMtx._22);
}


// ɓeꂽ瓊eZo
float LenSegOnSeparateAxis( D3DXVECTOR2 *Sep, D3DXVECTOR2 *e1, D3DXVECTOR2 *e2 )
{
	// 3̓ς̐Βl̘aœevZ
	// Sep͕WĂ邱
	float r1 = fabs(D3DXVec2Dot( Sep, e1 ));
	float r2 = fabs(D3DXVec2Dot( Sep, e2 ));
	return r1 + r2;
}

// OBB vs OBB
bool TestOBBOBB(const OBB &obb1,const OBB &obb2)
{
	// exNg̊m
	// iN***:WxNgj
	D3DXVECTOR2 NAe1 = obb1.Dir[0], Ae1 = NAe1 * obb1.Length[0];
	D3DXVECTOR2 NAe2 = obb1.Dir[1], Ae2 = NAe2 * obb1.Length[1];
	D3DXVECTOR2 NBe1 = obb2.Dir[0], Be1 = NBe1 * obb2.Length[0];
	D3DXVECTOR2 NBe2 = obb2.Dir[1], Be2 = NBe2 * obb2.Length[1];
	D3DXVECTOR2 Interval = obb1.Pos - obb2.Pos;

	//  : Ae1
	float rA = D3DXVec2Length( &Ae1 );
	float rB = LenSegOnSeparateAxis( &NAe1, &Be1, &Be2 );
	float L = fabs(D3DXVec2Dot( &Interval, &NAe1 ));
	if( L > rA + rB )
		return false; // Փ˂ĂȂ

	//  : Ae2
	rA = D3DXVec2Length( &Ae2 );
	rB = LenSegOnSeparateAxis( &NAe2, &Be1, &Be2);
	L = fabs(D3DXVec2Dot( &Interval, &NAe2 ));
	if( L > rA + rB )
		return false;

	//  : Be1
	rA = LenSegOnSeparateAxis( &NBe1, &Ae1, &Ae2);
	rB = D3DXVec2Length( &Be1 );
	L = fabs(D3DXVec2Dot( &Interval, &NBe1 ));
	if( L > rA + rB )
		return false;

	//  : Be2
	rA = LenSegOnSeparateAxis( &NBe2, &Ae1, &Ae2);
	rB = D3DXVec2Length( &Be2 );
	L = fabs(D3DXVec2Dot( &Interval, &NBe2 ));
	if( L > rA + rB )
		return false;

	// ʂ݂Ȃ̂ŁuՓ˂Ăv
	return true;
}

// XvCg̓蔻iQOBB vs OBBj
bool IsHitTest(const Sprite& sprite1,const Sprite& sprite2)
{
	OBB obb1;
	OBB obb2;
	D3DXMATRIX rotMtx1;
	D3DXMATRIX rotMtx2;

	D3DXMatrixRotationZ(&rotMtx1,sprite1.rotate);
	D3DXMatrixRotationZ(&rotMtx2,sprite2.rotate);
	CreateOBB(&obb1,sprite1.pos,rotMtx1,D3DXVECTOR2(sprite1.width/2.0f,sprite1.height/2.0f));
	CreateOBB(&obb2,sprite2.pos,rotMtx2,D3DXVECTOR2(sprite2.width/2.0f,sprite2.height/2.0f));
	return TestOBBOBB(obb1,obb2);
}